# Written and Refactor by keihan haqiq github@patpaws
# main versin of the the minCahce.
# from lru import LRUCache
from minCache.lru import LRUCache;
from minCache.dispatchPromptObject import PromptCached
from minCache.minhash import generateSignature, checkForSimilarity
from copy import copy
from minCache.llmSampleCall import llmCall
from minCache.processor import Processor
from minCache.sim_generator import Similarity
from minCache.adapter import createAdapterOutOf

class MINCACHE:
    def __init__(self, cacheSize=10, threshold=0.7, llmAdapter=llmCall, withWhat='minHash', perm=200):
        self.cache = LRUCache(cacheSize)
        self.threshold = threshold
        self.adapter = llmAdapter  # Treat the adapter as a property that the user must create a vllm instance and put it here
        self.cacheHit = 0
        self.cacheMiss = 0

        self.posHit = 0;
        self.negHit = 0;

        self.processor = Processor()
        self.similarEngine = Similarity(withWhat=withWhat, perm=perm)

    def incrCacheHit(self):
        self.cacheHit += 1

    def incrCacheMiss(self):
        self.cacheMiss += 1

    def incrPosHit(self) :
        self.posHit += 1;

    def incrNegHit(self) :
        self.negHit +=1 ;

    def cacheLoad (self, d) :
        for item in d :
            for flag in item :
                if flag == 'label' :
                    continue;
                else :
                    promptSign = self.processor.PreProcess(item['text_a'])
                    sig = self.similarEngine.generateRep(item['text_a'])
                    p, r = self.adapter(item['text_a'])
                    self.cache.put(promptSign, PromptCached(p, r, sig))

    def totalCacheStat(self):
        return {
            'cacheHitTotal': self.cacheHit,
            'cacheMissTotal': self.cacheMiss,
            'hitRate': f'{int((self.cacheHit / (self.cacheHit + self.cacheMiss)) * 100)}%',
            'missRate': f'{int((self.cacheMiss / (self.cacheHit + self.cacheMiss)) * 100)}%',
            'posHit' : self.posHit ,
            'negHit':self.negHit

        }


    def handle_test(self,prompt) :

        sig = self.similarEngine.generateRep(prompt['text_b'])
        promptSign = self.processor.PreProcess(prompt['text_b'])

        if not promptSign:
            return self.processor.PostProcess({
                'value': ['cant handle'],
                'typi': ['error']
            })


        return self.cacheManager_test(promptSign , sig , prompt);

        # # Check for the exact match (hard compare) first
        # if res := self.checkAgainstHard(promptSign):
        #     #print('cache hit : hardCache')
        #     self.incrCacheHit();
        #     return self.processor.PostProcess({
        #         'value': [res],
        #         'assert':1,
        #         'typi': 'exact'
        #     })

        # # Check for semantic similarity (cache)
        # valids = self.checkAgainstCache(sig)
        # if not valids:
        #     #print('we dont have any valid cache here so we do llm call cache hit 0')
        #     p, r = self.adapter(prompt['text_b'])
        #     self.cache.put(promptSign, PromptCached(p, r, sig))
        #     self.incrCacheMiss()
        #     return self.processor.PostProcess({
        #         'value': r,
        #         'assert':0,
        #         'typi': 'llm-raw'
        #     })
        # else:
        #     #print('cache hit : semantic');
        #     self.incrCacheHit()
        #     return self.processor.PostProcess({
        #         'value': valids,
        #         'assert':1,
        #         'typi': 'cache-out'
        #     })


    def handle(self, prompt):
        sig = self.similarEngine.generateRep(prompt['prompt'])
        promptSign = self.processor.PreProcess(prompt['prompt'])

        if not promptSign:
            return self.processor.PostProcess({
                'value': ['cant handle'],
                'typi': ['error']
            })


        return self.cacheManager(promptSign , sig , prompt);

        # # Check for the exact match (hard compare) first
        # if res := self.checkAgainstHard(promptSign):
        #     #print('cache hit : hardCache')
        #     self.incrCacheHit();
        #     return self.processor.PostProcess({
        #         'value': [res],
        #         'typi': 'exact'
        #     })

        # # Check for semantic similarity (cache)
        # valids = self.checkAgainstCache(sig)
        # if not valids:
        #     #print('we dont have any valid cache here so we do llm call cache hit 0')
        #     p, r = self.adapter(prompt['pr'])
        #     self.cache.put(promptSign, PromptCached(p, r, sig))
        #     self.incrCacheMiss()
        #     return self.processor.PostProcess({
        #         'value': r,
        #         'typi': 'llm-raw'
        #     })
        # else:
        #     #print('cache hit : semantic');
        #     self.incrCacheHit()

        #     return self.processor.PostProcess({
        #         'value': valids,
        #         'typi': 'cache-out'
        #     })


    def cacheManager_test(self, promptSign, sig, prompt) :
        if res := self.checkAgainstHard(promptSign):
            #print('cache hit : hardCache')
            self.incrCacheHit();
            return self.processor.PostProcess({
                'value': [res],
                'assert':1,
                'typi': 'exact'
            })

        # Check for semantic similarity (cache)
        valids = self.checkAgainstCache(sig)
        if not valids:
            #print('we dont have any valid cache here so we do llm call cache hit 0')
            p, r = self.adapter(prompt['text_b'])
            self.cache.put(promptSign, PromptCached(p, r, sig))
            self.incrCacheMiss()
            return self.processor.PostProcess({
                'value': r,
                'assert':0,
                'typi': 'llm-raw'
            })
        else:
            #print('cache hit : semantic');
            self.incrCacheHit()
            return self.processor.PostProcess({
                'value': valids,
                'assert':1,
                'typi': 'cache-out'
            })



    def cacheManager(self , promptSign , sig , prompt) :

        # Check for the exact match (hard compare) first
        if res := self.checkAgainstHard(promptSign):
            #print('cache hit : hardCache')
            self.incrCacheHit();
            return self.processor.PostProcess({
                'value': [res],
                'typi': 'exact'
            })

        # Check for semantic similarity (cache)
        valids = self.checkAgainstCache(sig)
        if not valids:
            #print('we dont have any valid cache here so we do llm call cache hit 0')
            p, r = self.adapter(prompt['pr'])
            self.cache.put(promptSign, PromptCached(p, r, sig))
            self.incrCacheMiss()
            return self.processor.PostProcess({
                'value': r,
                'typi': 'llm-raw'
            })
        else:
            #print('cache hit : semantic');
            self.incrCacheHit()

            return self.processor.PostProcess({
                'value': valids,
                'typi': 'cache-out'
            })
        pass;



    def checkAgainstHard(self, targetHash):
        cache_copy = copy(self.cache._cache)
        for cacheValue in cache_copy:
            if targetHash == cacheValue:
                return {
                    'key': cacheValue,
                    'value': cache_copy.get(cacheValue)
                }
        return False

    def checkAgainstCache(self, targetSig):
        valids = []
        cache_copy = copy(self.cache._cache)
        for cacheValue in cache_copy:
            cacheObject = cache_copy.get(cacheValue)


            scoreValue = self.similarEngine.checkAgainst(targetSig, cacheObject.getPromptRep())

            if float(scoreValue) >= float(self.threshold):
                valids.append({'key': cacheValue, 'value': cacheObject, 'score': scoreValue , 'assert':1})

        return sorted(valids, key=lambda x: x['score'], reverse=True)

def main():

    adt = createAdapterOutOf(llmCall)
    semCache = MINCACHE(3, 0.77, llmCall, perm=200)

    while True:
        userInput = input(" what is your root symptom > ")
        if userInput == 'exit':
            return
        res = semCache.handle(userInput)
        print(res)
        semCache.cache.monitor()
        print(semCache.totalCacheStat())
        print(res)

if __name__ == "__main__":
    main()
